# Sample add-on: GitHub Reader

This is a sample add-on that demonstrates using external services to bring
rich information into Gmail, as well as contextual triggering based on
email content. It triggers in response to messages containing links
[GitHub][github] issues or pull requests and displays additional relevant
information.



## Before you begin

If you're new to add-on development or [Apps Script][apps-script],
try the [quickstart][quickstart] before proceeding.

This sample requires the following:

-  [Node.js][node] is installed with `npm` and `npx` commands.

## Downloading the sample

Download the sample app and navigate into the app directory:

1. git clone 

2. Change to the sample directory:

        cd add-ons-samples/carbonCopy

3. Initialize the project:

        npm install

4. Bundle the dependencies:

        npm run build

## Deploy the add-on

Deploy the add-on by following these steps:

1.  Authorize clasp to manage your scripts

        npx @google/clasp login

2.  Create a new project:

        npx @google/clasp create --type standalone --title "Carbon Copy"

3.  Push the code:

        npx @google/clasp push -f

## Configure GitHub credentials

Access the GitHub API requires registration. To register your own application:

1.  Open the script editor:

        npx @google/clasp open

2.  Get the script id by clicking on **File > Project properties** and note the value of the **Script ID** field.

3.  Follow [GitHub's guide][github-oauth] to create an OAuth Application. Use the value `https://script.google.com/macros/d/{SCRIPT_ID}/usercallback` for the **Authorization callback URL**,
    replacing `{SCRIPT_ID}` with the script id located in the previous step.

4.  Create a script property with the credentials:

    a. Click on **File > Project properties > Script properties**.

	b. Click **Add row**.

	c. Enter the property name `githubCredentials`.

	d. Click on the blank area in the **Value** column.

	e. Enter the value below, subsituting the `{CLIENT_ID}` and `{CLIENT_SECRET}` with the values provided
	   by GitHub.

	    {"clientId": "{CLIENT_ID}", "clientSecret": "{CLIENT_SECRET}" }

	f. Click **Save**.

## Install the add-on

Once the add-on is deployed, install the add-on on your account using these steps:

1.  Open the project

        npx @google/clasp open
        
2. In the Apps Script editor, select **Publish > Deploy from manifest...** to open the *Deployments* dialog.

3. In the **Latest Version (Head)** row, click **Install add-on** to install the currently saved version of the add-on in development-mode. 

## Run the add-on

1.  Open [Gmail][gmail]. If Gmail was open prior to enabling the add-on,
    you may need to refresh the tab.

2.  Open a message in Gmail.

3.  The add-on should place a contextual card on the right-side of the window,
    with a message asking for authorization. Click the **Authorize access** link
    to open a dialog where you can authorize the add-on.

4.  Select the account that should authorize the add-on.

5.  Read the notice in the next dialog carefully, then click **Allow**.

6.  Once authorized, the add-on should automatically refresh and start operating.

## Contributing

Please read our [guidelines for contributors][contributing].

## License

This sample is licensed under the [Apache 2 license][license].

<!-- References -->
[quickstart]:https://developers.google.com/gsuite/add-ons/cats-quickstart
[node]:https://nodejs.org/en/
[apps-script]: https://script.google.com
[github-repo]: https://github.com/googleworkspace/add-ons-samples
[github-zip]: https://github.com/googleworkspace/add-ons-samples/archive/master.zip
[contributing]: https://github.com/googleworkspace/add-ons-samples/blob/master/CONTRIBUTING.md
[license]: https://github.com/googleworkspace/add-ons-samples/blob/master/LICENSE
[gmail]: https://mail.google.com/
[github]: https://github.com
[github-oauth]: https://developer.github.com/apps/building-integrations/setting-up-and-registering-oauth-apps/registering-oauth-apps/
